/*
 * acl.c - access control and authentication functions
 */

#include "config.h"
#ifdef ACL
#include "sockutils.h"
#include "afdp.h"
#include "afdplib.h"
#include "afdpjoin.h"
#include "md5.h"
#include "acl.h"

#define MAX_ALLOWED 20

static unsigned long sa[MAX_ALLOWED]; /* ACL subscriber addresses */
static unsigned long sm[MAX_ALLOWED]; /* ACL subscriber masks */
static unsigned long pa[MAX_ALLOWED]; /* ACL publisher addresses */
static unsigned long pm[MAX_ALLOWED]; /* ACL publisher masks */

char key[AUTHDATA_SZ];

int CheckAuth(packet_start *packet, int pack_len, unsigned long *from)
{
  MD5_CTX context;
  int foo;
  unsigned char new_authdata[AUTHDATA_SZ];
  unsigned char old_authdata[AUTHDATA_SZ];

  for (foo = 0; sm[foo]; foo++)
    if ((*from & sm[foo]) == sa[foo])
      break;

  if (!sa[foo])
    return 1;
  
  bcopy(packet->authdata, old_authdata, AUTHDATA_SZ);
  bzero(packet->authdata, AUTHDATA_SZ);

  MD5Init(&context);
  MD5Update(&context, (char *)packet, pack_len);
  MD5Update(&context, (char *)from, sizeof(int));
  MD5Update(&context, key, AUTHDATA_SZ);
  MD5Final(new_authdata, &context);

  if (bcmp(new_authdata, old_authdata, AUTHDATA_SZ))
    return 1;

  return 0;
}

void GenAuth(packet_start *packet, int pack_len, unsigned long *from)
{
  MD5_CTX context;

  bzero(packet->authdata, AUTHDATA_SZ);

  MD5Init(&context);
  MD5Update(&context, (char *)packet, pack_len);
  MD5Update(&context, from, sizeof(int));
  MD5Update(&context, key, AUTHDATA_SZ);
  MD5Final(packet->authdata, &context);
}

void ReadACLFile(char *filename)
{
  
}
#endif /* ACL */
