/*
 *	Copyright (c) 1994, 1995 by Jeremy Cooperstock and Steve Kotsopoulos,
 *	All Rights Reserved.
 */

/*
 * config.h - AFDP config file
 *
 * rcsid[] = "$Id: config.h,v 1.18 1995/11/21 19:27:08 steve Exp $";
 *
 */

/* thanks to John DiMarco <jdd@cdf.toronto.edu> for Solaris/SunOS test. */
/* FILENAME_MAX is defined in stdio.h on Solaris but not on SunOS. */
#include <stdio.h>
#ifdef sun
#ifdef FILENAME_MAX
#define Solaris
#else
#define SunOS
#endif
#endif

#if defined(mips) && !defined(sgi)
#define MIPS		/* we are on a MIPS host (runs RISC/os), not an SGI */
#endif

#ifdef sgi
#if defined(__sgi)
#define NEWSGI		/* we are on an SGI, running IRIX 4.x or 5.x */
#else
#define OLDSGI		/* we are on an SGI, running IRIX 3.x */
#endif
#endif

#ifndef MULTICAST
#if defined (sgi) || defined (Solaris) || defined (__bsdi__)
#define MULTICAST
#endif
#endif

/* define the following, if you want to use the IDENT service */
#define IDENT

/* for afdpsend.c */
#define DEF_STEPSIZE	(10 * mSEC)	/* how much to speedup as we go    */
#define DEF_MIN_INTERVAL (5 * mSEC)	/* puts upper bound on packet rate */
#define DEF_MAX_INTERVAL (500 * mSEC)	/* puts lower bound on packet rate */
#define DEF_WINDOWSIZE  100		/* how far back to allow resend req */
#define DEF_CACHESIZE   100000		/* max mem allocatable by publisher */
#define LINGER_TIME	5       	/* default linger time 		   */	

/* for secretary.c */
#define DEF_THRESHOLD	3		/* when to switch from uni to multi  */
#define INTERNET_THRESHOLD 99999	/* prevents broadcasting to hosts    */
#define CLIENT_WAIT (10 * SECOND)	/* time client should wait for retry */
#define DEF_TPP (50 * mSEC)		/* default time per packet */
#define MAX_NAMELEN 10			/* max user login name  */
#define MAXMEMBERS 100
#define MAXCLIENTS 5

/* for subscriber.c */
#define WAIT_TIME    (100 * mSEC)	/* delay between successive checks */
#define RESEND_REQUEST_TIME  SECOND	/* delay between successive requests */
#define FREE_TIME    (60 * SECOND)	/* time to wait before freeing entry */
#define MAX_TIMEOUTS 5			/* max waits before asking for rest */
#define MAX_RESEND_PACKETS 10		/* max packets to request in a resend */
#define MAX_BACKOFF_COUNT  10		/* backoff at most 10 counts */
